package com.yidianling.dynamic.trendsHome

import android.content.Intent
import android.os.Build
import android.os.Bundle
import android.os.Handler
import android.view.View
import android.widget.FrameLayout
import android.widget.ImageView
import android.widget.TextView
import androidx.appcompat.widget.Toolbar
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.fragment.app.Fragment
import androidx.swiperefreshlayout.widget.SwipeRefreshLayout
import androidx.viewpager.widget.ViewPager
import butterknife.BindView
import butterknife.ButterKnife
import butterknife.OnClick
import butterknife.Unbinder
import com.alibaba.android.arouter.facade.annotation.Route
import com.google.android.material.appbar.AppBarLayout
import com.google.android.material.appbar.CollapsingToolbarLayout
import com.google.android.material.floatingactionbutton.FloatingActionButton
import com.ydl.ydl_image.module.GlideApp
import com.ydl.ydlcommon.base.BaseFragment
import com.ydl.ydlcommon.utils.BuryPointUtils
import com.ydl.ydlcommon.utils.ScreenUtil
import com.ydl.ydlcommon.utils.actionutil.ActionCountUtils.Companion.count
import com.yidianling.common.tools.RxDeviceTool
import com.yidianling.common.tools.RxImageTool
import com.yidianling.dynamic.R
import com.yidianling.dynamic.R2
import com.yidianling.dynamic.bean.DynamicConstants
import com.yidianling.dynamic.common.view.LooperTextView
import com.yidianling.dynamic.model.TopicListDataBean
import com.yidianling.dynamic.model.TrendsListBean
import com.yidianling.dynamic.model.TrendsListBean.ExtData
import com.yidianling.dynamic.publishTrend.PublishTrendActivity
import com.yidianling.dynamic.router.DynamicIn.loginByOneKeyLogin
import com.yidianling.dynamic.topic.AllTopicActivity
import com.yidianling.dynamic.topic.topicDetail.TopicDetailActivity
import com.yidianling.dynamic.trendsHome.content.TrendsContentListFragment
import com.yidianling.dynamic.trendsHome.view.TrendsHomeBannerView
import jp.wasabeef.glide.transformations.RoundedCornersTransformation

/**
 * Created by Jim on 2017/9/22 0022.
 * 首页问答fragment
 */
@Route(path = "/dynamic/dynamic")
class TrendsHomeFragment : BaseFragment(), ITrendHomeView, SwipeRefreshLayout.OnRefreshListener {
    @JvmField
    @BindView(R2.id.trend_home_swl)
    var swl: SwipeRefreshLayout? = null

    @JvmField
    @BindView(R2.id.vp_content)
    var vpContent: ViewPager? = null

    @JvmField
    @BindView(R2.id.trends_topic_iv1)
    var topicRoundIv1: ImageView? = null

    @JvmField
    @BindView(R2.id.trends_topic_iv2)
    var topicRoundIv2: ImageView? = null

    @JvmField
    @BindView(R2.id.trends_topic_iv3)
    var topicRoundIv3: ImageView? = null

    @JvmField
    @BindView(R2.id.trends_home_csl)
    var mConstraintLayout: ConstraintLayout? = null

    @JvmField
    @BindView(R2.id.trends_tv_mind_group)
    var tvMindGroup: TextView? = null

    @JvmField
    @BindView(R2.id.trends_tv_mind_more)
    var tvMindMore: TextView? = null

    @JvmField
    @BindView(R2.id.frl_topic_iv3)
    var frlTopicIv3: FrameLayout? = null

    @JvmField
    @BindView(R2.id.frl_topic_iv2)
    var frlTopicIv2: FrameLayout? = null

    @JvmField
    @BindView(R2.id.frl_topic_iv1)
    var frlTopicIv1: FrameLayout? = null

    @JvmField
    @BindView(R2.id.trends_home_appBar)
    var mAppBarLayout: AppBarLayout? = null

    @JvmField
    @BindView(R2.id.item_recommend_tv)
    var mItemRecommendTv: TextView? = null

    @JvmField
    @BindView(R2.id.item_hot_tv)
    var mItemHotTv: TextView? = null

    @JvmField
    @BindView(R2.id.item_focus_tv)
    var mItemFocusTv: TextView? = null

    @JvmField
    @BindView(R2.id.trends_topic_tv3)
    var trendsTopicTv3: TextView? = null

    @JvmField
    @BindView(R2.id.trends_topic_tv2)
    var trendsTopicTv2: TextView? = null

    @JvmField
    @BindView(R2.id.trends_topic_tv1)
    var trendsTopicTv1: TextView? = null

    @JvmField
    @BindView(R2.id.publish_trend_btn)
    var mPublishTrendButton: FloatingActionButton? = null

    @JvmField
    @BindView(R2.id.ternd_loop_tv)
    var mLooperTextView: LooperTextView? = null

    @JvmField
    @BindView(R2.id.toolbar_tv)
    var mToolBarTv: Toolbar? = null

    @JvmField
    @BindView(R2.id.v_banner)
    var v_banner: TrendsHomeBannerView? = null
    private var mUnbinder: Unbinder? = null
    private var mPresenter: TrendsHomePresenter? = null
    private lateinit var mFragments: Array<Fragment>
    private var vpAdapter: TrendsHomeVpAdapter? = null
    private val lastTabClick: Long = 0
    private var currentPostion = -1
    var tab: String? = null
    private var startTime: Long = 0
    private var endTime: Long = 0
    fun setTab(tab: String?): TrendsHomeFragment {
        this.tab = tab
        return this
    }

    override fun layoutResId(): Int {
        return R.layout.dynamic_fragment_moments
    }

    override fun initDataAndEvent() {
        mUnbinder = ButterKnife.bind(this, requireView())
        initViews()
        initDatas()
    }

    override fun initDataAndEventLazy() {
//        initDatas();
    }

    private fun initViews() {
        initBannerView()
        swl!!.setOnRefreshListener(this)
        swl!!.setColorSchemeResources(R.color.platform_main_theme)
        mAppBarLayout!!.addOnOffsetChangedListener(AppBarLayout.OnOffsetChangedListener { appBarLayout, verticalOffset ->
            if (verticalOffset == 0) {
                swl!!.isEnabled = true
            } else {
                swl!!.isEnabled = false
            }
            if (verticalOffset <= -appBarLayout.totalScrollRange + mToolBarTv!!.height) {
                mToolBarTv!!.alpha = 1f
            } else {
                mToolBarTv!!.alpha = 0f
            }
        })
        initStatus()
    }

    private fun initStatus() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) { //4.4以下不支持状态栏变色
            val statusBarHeight = ScreenUtil.getStatusBarHeight(activity)
            val layoutParams = mToolBarTv!!.layoutParams as CollapsingToolbarLayout.LayoutParams
            layoutParams.height =
                (resources.getDimension(R.dimen.title_bar_height) + statusBarHeight).toInt()
            mToolBarTv!!.setPadding(0, statusBarHeight, 0, 0)
            mToolBarTv!!.layoutParams = layoutParams
        }
    }

    private fun initDatas() {
        mPresenter = TrendsHomePresenter()
        mPresenter!!.callBack = this
        mPresenter!!.fetchDats()
    }

    private fun initBannerView() {
        val screenSize = RxDeviceTool.getScreenWidth(activity)
        val topicRoundIv1Width = (screenSize - RxImageTool.dip2px(31f)) * 2 / 3
        val topicRoundIv23Width = (screenSize - RxImageTool.dip2px(31f)) / 3
        val topicRoundIv1Height = (topicRoundIv1Width / 1.5f).toInt()
        val topicRoundIv23Height = ((topicRoundIv1Height - RxImageTool.dip2px(1f)) / 2f).toInt()
        val params1 = ConstraintLayout.LayoutParams(topicRoundIv1Width, topicRoundIv1Height)
        params1.topMargin = RxImageTool.dp2px(10f)
        params1.leftMargin = RxImageTool.dp2px(15f)
        params1.leftToRight = mConstraintLayout!!.id
        params1.topToBottom = tvMindGroup!!.id
        frlTopicIv1!!.layoutParams = params1
        val params2 = ConstraintLayout.LayoutParams(topicRoundIv23Width, topicRoundIv23Height)
        params2.topMargin = RxImageTool.dp2px(10f)
        params2.leftMargin = RxImageTool.dp2px(1f)
        params2.leftToRight = frlTopicIv1!!.id
        params2.topToBottom = tvMindGroup!!.id
        frlTopicIv2!!.layoutParams = params2
        val params3 = ConstraintLayout.LayoutParams(topicRoundIv23Width, topicRoundIv23Height)
        params3.topMargin = RxImageTool.dp2px(1f)
        params3.leftMargin = RxImageTool.dp2px(1f)
        params3.leftToRight = frlTopicIv1!!.id
        params3.topToBottom = frlTopicIv2!!.id
        frlTopicIv3!!.layoutParams = params3
    }

    override fun setUserVisibleHint(isVisibleToUser: Boolean) {
        super.setUserVisibleHint(isVisibleToUser)
        if (isVisibleToUser && isResumed) {
            startTime = System.currentTimeMillis()
            count(DynamicConstants.YDL_USER_ASK_PAGE_VISIT)
        } else {
            if (startTime != 0L) {
                endTime = System.currentTimeMillis()
                count(
                    DynamicConstants.YDL_USER_ASK_PAGE_STAY_VISIT,
                    (endTime - startTime).toString()
                )
            }
        }
        if (isVisibleToUser && isResumed) {
            onResume()
        }
    }

    private fun initViewPager() {
        vpAdapter = TrendsHomeVpAdapter(childFragmentManager, mFragments)
        vpContent!!.adapter = vpAdapter
        vpContent!!.offscreenPageLimit = 1
        vpContent!!.addOnPageChangeListener(object : ViewPager.OnPageChangeListener {
            override fun onPageScrolled(
                position: Int,
                positionOffset: Float,
                positionOffsetPixels: Int
            ) {
            }

            override fun onPageSelected(position: Int) {
                if (position == currentPostion) {
                    return
                }
                currentPostion = position
                if (position >= 1) {
                    vpContent!!.offscreenPageLimit = 2
                }
                switchTab(position)
                when (position) {
                    0 -> {
                        BuryPointUtils.getInstance().createMap()
                            .put("toptab_name", "推荐")
                            .burryPoint("topTabClick")
                        BuryPointUtils.getInstance().trackViewScreen(
                            activity,
                            "动态-推荐",
                            "com.cxzapp.yidianling.trends.trendList.TrendsListFragment"
                        )
                    }
                    1 -> {
                        BuryPointUtils.getInstance().createMap()
                            .put("toptab_name", "最新")
                            .burryPoint("topTabClick")
                        BuryPointUtils.getInstance().trackViewScreen(
                            activity,
                            "动态-最新",
                            "com.cxzapp.yidianling.trends.trendList.TrendsListFragment"
                        )
                    }
                    2 -> {
                        BuryPointUtils.getInstance().createMap()
                            .put("toptab_name", "关注")
                            .burryPoint("topTabClick")
                        if (!loginByOneKeyLogin(activity!!, true)) {
                            return
                        }
                        BuryPointUtils.getInstance().trackViewScreen(
                            activity,
                            "动态-关注",
                            "com.cxzapp.yidianling.trends.trendList.TrendsListFragment"
                        )
                    }
                }
            }

            override fun onPageScrollStateChanged(state: Int) {}
        })
        if ("hot" == tab) {
            vpContent!!.currentItem = 1
            switchTab(1)
        } else if ("new" == tab) {
            vpContent!!.currentItem = 0
            switchTab(0)
        } else {
            vpContent!!.currentItem = 0
            switchTab(0)
        }
    }

    private fun switchTab(index: Int) {
        when (index) {
            0 -> {
                mItemRecommendTv!!.isSelected = false
                mItemRecommendTv!!.setTextColor(resources.getColor(R.color.dynamic_text_666666))
                mItemFocusTv!!.isSelected = false
                mItemFocusTv!!.setTextColor(resources.getColor(R.color.dynamic_text_666666))
                mItemHotTv!!.isSelected = true
                mItemHotTv!!.setTextColor(resources.getColor(R.color.platform_but_text_color))
            }
            1 -> {
                mItemRecommendTv!!.isSelected = true
                mItemRecommendTv!!.setTextColor(resources.getColor(R.color.platform_but_text_color))
                mItemFocusTv!!.isSelected = false
                mItemFocusTv!!.setTextColor(resources.getColor(R.color.dynamic_text_666666))
                mItemHotTv!!.isSelected = false
                mItemHotTv!!.setTextColor(resources.getColor(R.color.dynamic_text_666666))
            }
            2 -> {
                mItemRecommendTv!!.isSelected = false
                mItemRecommendTv!!.setTextColor(resources.getColor(R.color.dynamic_text_666666))
                mItemFocusTv!!.isSelected = true
                mItemFocusTv!!.setTextColor(resources.getColor(R.color.platform_but_text_color))
                mItemHotTv!!.isSelected = false
                mItemHotTv!!.setTextColor(resources.getColor(R.color.dynamic_text_666666))
            }
        }
    }

    @OnClick(
        R2.id.trends_tv_mind_more,
        R2.id.publish_trend_btn,
        R2.id.item_recommend_tv,
        R2.id.item_hot_tv,
        R2.id.item_focus_tv
    )
    fun doClick(view: View) {
        if (view.id == R.id.item_recommend_tv) {
            count(DynamicConstants.YDL_USER_ASK_TYPE_CLICK, "推荐")
            vpContent!!.currentItem = 1
        } else if (view.id == R.id.item_hot_tv) {
            count(DynamicConstants.YDL_USER_ASK_TYPE_CLICK, "最新")
            vpContent!!.currentItem = 0
        } else if (view.id == R.id.item_focus_tv) {
            count(DynamicConstants.YDL_USER_ASK_TYPE_CLICK, "关注")
            vpContent!!.currentItem = 2
        } else if (view.id == R.id.publish_trend_btn) {
            //发布动态
            count(DynamicConstants.YDL_USER_ASK_QUESTIONS_BUTTON_CLICK)
            if (loginByOneKeyLogin(requireActivity(), true)) {
                val intent = Intent(requireActivity().applicationContext, PublishTrendActivity::class.java)
                //默认改为今日打卡
                val bundle = Bundle()
                bundle.putString(DynamicConstants.PUBLISH_TYPE, "topic_publish")
                bundle.putString("topic_id", "44")
                bundle.putString("topic_title", "今日打卡")
                intent.putExtra("bundle", bundle)
                startActivity(intent)
            }
        } else if (view.id == R.id.trends_tv_mind_more) {
            count(DynamicConstants.YDL_USER_THOUGHTS_GROUP_MORE_CLICK)
            val intent = Intent(activity, AllTopicActivity::class.java)
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            startActivity(intent)
        }
        //        else if (view.getId() == R.id.iv_background) {
//            YDLRouterManager.Companion.router(IYDLRouterConstant.ROUTER_FM_LIST);
//        }
    }

    override fun onFetchedDatas(fragments: Array<Fragment>) {
        mFragments = fragments
        initViewPager()
    }

    fun setBannerData(list: List<TrendsListBean.Banner>) {
        v_banner!!.initData(list)
    }

    override fun onFetchedDataFailed() {}
    fun displayShowCase() {}
    override fun onDestroyView() {
        super.onDestroyView()
        mUnbinder!!.unbind()
    }

    override fun onRefresh() {
        swl!!.isRefreshing = true
        Handler().postDelayed({
            (mFragments[vpContent!!.currentItem] as TrendsContentListFragment).onRefresh()
            swl!!.isRefreshing = false
        }, 300)
    }

    fun showMindsGroup(topicListDatas: TopicListDataBean) {
        if (topicListDatas.list == null || topicListDatas.list.size <= 0) {
            return
        }
        var i = 0
        while (i < 3 && i < topicListDatas.list.size) {
            when (i) {
                0 -> {
                    GlideApp.with(this)
                        .load(topicListDatas.list[i].img_bg_url)
                        .centerCrop()
                        .transform(
                            RoundedCornersTransformation(
                                20,
                                0,
                                RoundedCornersTransformation.CornerType.LEFT
                            )
                        )
                        .into(topicRoundIv1!!)
                    trendsTopicTv1!!.text = topicListDatas.list[i].topic_title
                    frlTopicIv1!!.setOnClickListener { view: View? ->
                        mindTopicClick(
                            topicListDatas.list[0].topic_title,
                            topicListDatas.list[0].topic_id,
                            trendsTopicTv1!!.text.toString()
                        )
                    }
                }
                1 -> {
                    GlideApp.with(this)
                        .load(topicListDatas.list[i].img_bg_url)
                        .centerCrop()
                        .transform(
                            RoundedCornersTransformation(
                                20,
                                0,
                                RoundedCornersTransformation.CornerType.TOP_RIGHT
                            )
                        )
                        .into(topicRoundIv2!!)
                    trendsTopicTv2!!.text = topicListDatas.list[i].topic_title
                    frlTopicIv2!!.setOnClickListener { view: View? ->
                        mindTopicClick(
                            topicListDatas.list[1].topic_title,
                            topicListDatas.list[1].topic_id,
                            trendsTopicTv2!!.text.toString()
                        )
                    }
                }
                2 -> {
                    GlideApp.with(this)
                        .load(topicListDatas.list[i].img_bg_url)
                        .centerCrop()
                        .transform(
                            RoundedCornersTransformation(
                                20,
                                0,
                                RoundedCornersTransformation.CornerType.BOTTOM_RIGHT
                            )
                        )
                        .into(topicRoundIv3!!)
                    trendsTopicTv3!!.text = topicListDatas.list[i].topic_title
                    frlTopicIv3!!.setOnClickListener { view: View? ->
                        mindTopicClick(
                            topicListDatas.list[2].topic_title,
                            topicListDatas.list[2].topic_id,
                            trendsTopicTv3!!.text.toString()
                        )
                    }
                }
            }
            i++
        }
    }

    private fun mindTopicClick(title: String, id: String, imgName: String) {
        BuryPointUtils.getInstance().createMap()
            .put("theme_name", title)
            .put("theme_ID", id)
            .burryPoint("Theme_click")
        count(DynamicConstants.YDL_USER_THOUGHTS_GROUP_TYPE_CLICK, imgName)
        val intent = Intent()
        intent.setClass(activity, TopicDetailActivity::class.java)
        intent.putExtra("topic_id", id)
        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
        requireActivity().startActivity(intent)
    }

    fun showTopTrend(extDatas: List<ExtData?>?) {
        mLooperTextView!!.setTipList(extDatas)
    }

    fun setGoneLooperTextView() {
        mLooperTextView!!.visibility = View.GONE
    }

    companion object {
        fun newInstance(): TrendsHomeFragment {
            return TrendsHomeFragment()
        }
    }
}